Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp	(revision 88)
@@ -382,296 +476,115 @@
 		    {
 		      LABEL("BRANCH_COMPLETE [%d] - Transaction accepted",port);
-		      find = true;
+		      have_transaction = true;
 		      
-		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_MISS_PREDICTION[port]->read(),0);
-		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_TAKE           [port]->read(),1);
-		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_SRC    [port]->read(),0xdeadbeef+i);
-		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_DEST   [port]->read(),0x21071981+i);
+		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_MISS_PREDICTION[port]->read(),it_upt->miss_commit );
+		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_TAKE           [port]->read(),it_upt->take_good   );
+		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_SRC    [port]->read(),it_upt->address_src );
+		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_DEST   [port]->read(),it_upt->address_good);
+
+                      it_upt ++;
 		    }
 		  
 		  SC_START(1);
-
-		} while (not find);
-	      in_BRANCH_COMPLETE_VAL              [port]->write(0);
+		} while (not have_transaction);
+
+	      in_BRANCH_COMPLETE_VAL [port]->write(0);
 	      
-	      if (_param->_have_port_depth[context])
-		{
-		  TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
-		}
-		  TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
+              if (_param->_have_port_depth)
+              TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
+              TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
 	    }
 	}
+
+	{
+          LABEL("UPDATE - hit ifetch");
 	
-	LABEL("UPDATE - hit ifetch");
+	  uint32_t port = 0;
 	
-	{
-	  uint32_t port = 0; //rand() % _param->_nb_inst_update;
-	  
-	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
+          LABEL("  * port    : %d",port);
+          std::list<request_t>::iterator it_upt = upt.begin();
+  
+// 	  for (uint32_t i=0; i<_param->_size_ufpt_queue[context]; i++)
+	  for (uint32_t i=0; i<upt.size(); i++)
 	    {
-	      bool find = false;
+              LABEL("Address_src (-1): %.8x (%d)",out_UPDATE_BTB_ADDRESS_SRC [i]->read(),upt.size());
+
+	      bool have_transaction = false;
+
 	      do
 		{
+                  LABEL("Address_src (0) : %.8x",out_UPDATE_BTB_ADDRESS_SRC [i]->read());
+
 		  in_UPDATE_ACK [port]->write((rand()%100)<percent_transaction_update);
-		  
+
+//                   if (_param->_have_port_depth)
+//                   TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
+//                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+		  
+                  LABEL("Address_src (1) : %.8x",out_UPDATE_BTB_ADDRESS_SRC [i]->read());
 		  SC_START(0);
+                  LABEL("Address_src (2) : %.8x",out_UPDATE_BTB_ADDRESS_SRC [i]->read());
+		  
+		  LABEL("UPDATE [%d] %d - %d.",port,out_UPDATE_VAL [port]->read(),in_UPDATE_ACK [port]->read());
 		  
 		  if (out_UPDATE_VAL [port]->read() and in_UPDATE_ACK [port]->read())
 		    {
 		      LABEL("UPDATE [%d] - Transaction accepted",port);
-		      
-		      find = true;
-		      
-		      TEST(Tcontext_t         ,out_UPDATE_CONTEXT_ID            [port]->read(), context);
-		      TEST(Tcontrol_t         ,out_UPDATE_MISS_PREDICTION       [port]->read(), 0);
-		      TEST(Tcontrol_t         ,out_UPDATE_DIRECTION_GOOD        [port]->read(), 1);
-		      TEST(Tcontrol_t         ,out_UPDATE_BTB_VAL               [port]->read(), 1);
-		      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_SRC       [port]->read(), 0xdeadbeef+i);
-		      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_DEST      [port]->read(), 0x21071981+i);	      
-		      TEST(Tbranch_condition_t,out_UPDATE_BTB_CONDITION         [port]->read(), BRANCH_CONDITION_FLAG_SET);
-		      TEST(Tcontrol_t         ,out_UPDATE_DIR_VAL               [port]->read(), 1);
-		      if (_param->_have_port_history)
-			TEST(Thistory_t         ,out_UPDATE_DIR_HISTORY           [port]->read(), i);
-		      TEST(Tcontrol_t         ,out_UPDATE_RAS_VAL               [port]->read(), 0);
-		      TEST(Tcontrol_t         ,out_UPDATE_RAS_PUSH              [port]->read(), 0);
-		      TEST(Taddress_t         ,out_UPDATE_RAS_ADDRESS           [port]->read(), 0xdeaddead+i);
-		      TEST(Tptr_t             ,out_UPDATE_RAS_INDEX             [port]->read(), (0x12345678+i)%_param->_size_ras_index[context]);
-		      TEST(Tcontrol_t         ,out_UPDATE_RAS_PREDICTION_IFETCH [port]->read(), 1);
+		      have_transaction = true;
+		  
+                      if (_param->_have_port_context_id)
+                      TEST(Tcontext_t         ,out_UPDATE_CONTEXT_ID            [i]->read(),it_upt->context);
+                      TEST(Tcontrol_t         ,out_UPDATE_MISS_PREDICTION       [i]->read(),it_upt->miss_commit);
+                      TEST(Tcontrol_t         ,out_UPDATE_DIRECTION_GOOD        [i]->read(),it_upt->flag);
+                      TEST(Tcontrol_t         ,out_UPDATE_BTB_VAL               [i]->read(),update_btb(it_upt->condition));
+                      if (update_btb(it_upt->condition))
+                        {
+                      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_SRC       [i]->read(),it_upt->address_src);
+                      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_DEST      [i]->read(),it_upt->address_dest);
+                      TEST(Tbranch_condition_t,out_UPDATE_BTB_CONDITION         [i]->read(),it_upt->condition);
+                        }
+                      TEST(Tcontrol_t         ,out_UPDATE_DIR_VAL               [i]->read(),update_dir(it_upt->condition));
+                      if (update_dir(it_upt->condition))
+                      if (_param->_have_port_history)
+                      TEST(Thistory_t         ,out_UPDATE_DIR_HISTORY           [i]->read(),it_upt->history);
+                      TEST(Tcontrol_t         ,out_UPDATE_RAS_VAL               [i]->read(),update_ras(it_upt->condition));
+                      if (update_ras(it_upt->condition))
+                        {
+                      TEST(Tcontrol_t         ,out_UPDATE_RAS_PUSH              [i]->read(),push_ras  (it_upt->condition));
+                      TEST(Taddress_t         ,out_UPDATE_RAS_ADDRESS           [i]->read(),it_upt->ras_address);
+                      TEST(Tptr_t             ,out_UPDATE_RAS_INDEX             [i]->read(),it_upt->ras_index);
+                      TEST(Tcontrol_t         ,out_UPDATE_RAS_PREDICTION_IFETCH [i]->read(),not it_upt->miss_ifetch);
+                        }
+                      ++ it_upt;
 		    }
-		  
+
 		  SC_START(1);
-		  
-		} while (not find);
-	      in_UPDATE_ACK              [port]->write(0);
+                  LABEL("Address_src (3) : %.8x",out_UPDATE_BTB_ADDRESS_SRC [i]->read());
+                  
+		} while (not have_transaction);
+
+              LABEL("Address_src (4) : %.8x",out_UPDATE_BTB_ADDRESS_SRC [i]->read());
+	      in_UPDATE_ACK [port]->write(0);
+              LABEL("Address_src (5) : %.8x",out_UPDATE_BTB_ADDRESS_SRC [i]->read());
+//               if (_param->_have_port_depth)
+//               TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
+//               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
 	    }
-	  
-	  LABEL("Wait a moment");
-	  SC_START(2*_param->_size_queue[context]);
-  
-	  // wait the garbage collector
-	  while ((not (_param->_have_port_depth[context]) or (out_DEPTH_TAIL     [context]->read() != 0)) and
-		 (out_DEPTH_NB_BRANCH[context]->read() != 0))
-	    {
-	      LABEL("DEPTH [%d] nb_branch : %d - tail : %d",context,out_DEPTH_NB_BRANCH[context]->read(), out_DEPTH_TAIL [context]->read());
-	      SC_START(1);
-	    }
+          upt.clear();
 	}
+
+        // Wait Garbage Collector
+        {
+          upt_bottom [context] = (upt_bottom [context]+_param->_size_ufpt_queue[context])%_param->_size_upt_queue[context];
+//        upt_top    [context] = (upt_top    [context]);
+
+          while ((upt_bottom [context] != out_DEPTH_MIN [context]->read()) or
+                 (upt_top    [context] != out_DEPTH_MAX [context]->read()))
+            SC_START(1);
+
+        }
       }
 
-      {
-	uint32_t context = rand() % _param->_nb_context;
-	
-// 	LABEL("KANE : %d",context);
-
-	LABEL("PREDICT - fill the queue");
-	
-	{
-	  uint32_t port = rand() % _param->_nb_inst_predict;
-	  
-	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
-	    {
-	      
-	      bool find = false;
-	      do
-		{
-		  in_PREDICT_VAL              [port]->write((rand()%100)<percent_transaction_predict);
-		  in_PREDICT_CONTEXT_ID       [port]->write(context);
-		  in_PREDICT_BTB_ADDRESS_SRC  [port]->write(0xdeadbeef+i);
-		  in_PREDICT_BTB_ADDRESS_DEST [port]->write(0x21071981+i);
-		  in_PREDICT_BTB_CONDITION    [port]->write(BRANCH_CONDITION_FLAG_SET);
-		  in_PREDICT_BTB_LAST_TAKE    [port]->write(1);
-		  in_PREDICT_BTB_IS_ACCURATE  [port]->write((rand()%100)<percent_transaction_predict);
-		  in_PREDICT_DIR_HISTORY      [port]->write(i);
-		  in_PREDICT_RAS_ADDRESS      [port]->write(0xdeaddead+i);
-		  in_PREDICT_RAS_INDEX        [port]->write((0x12345678+i)%_param->_size_ras_index[context]);
-		  
-		  if (_param->_have_port_depth[context])
-		    {
-		      TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
-		    }
-		      TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), i);
-
-		  SC_START(0);
-		  
-		  LABEL("PREDICT         [%d] %d - %d (accurate : %d).",port,in_PREDICT_VAL [port]->read(),out_PREDICT_ACK [port]->read(), in_PREDICT_BTB_IS_ACCURATE [port]->read());
-		  
-		  if (in_PREDICT_VAL [port]->read() and out_PREDICT_ACK [port]->read())
-		    {
-		      LABEL("PREDICT         [%d] - Transaction accepted",port);
-		      find = true;
-		    }
-		  
-		  SC_START(1);
-		  
-		} while (not find);
-	      in_PREDICT_VAL              [port]->write(0);
-	      
-	      if (_param->_have_port_depth[context])
-		{
-		  TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
-		}
-		  TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), i+1);
-	    }
-	}
-	
-	LABEL("DECOD - hit ifetch");
-	
-	{
-	  uint32_t port = rand() % _param->_nb_inst_decod;
-	  
-	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
-	    {
-	      
-	      bool find = false;
-	      do
-		{
-		  in_DECOD_VAL                  [port]->write((rand()%100)<percent_transaction_decod);
-		  in_DECOD_CONTEXT_ID           [port]->write(context);
-		  in_DECOD_BTB_ADDRESS_SRC      [port]->write(0xdeadbeef+i);
-		  in_DECOD_BTB_ADDRESS_DEST     [port]->write(0x21071981+i);
-		  in_DECOD_BTB_CONDITION        [port]->write(BRANCH_CONDITION_FLAG_SET);
-		  in_DECOD_BTB_LAST_TAKE        [port]->write(1);
-		  in_DECOD_RAS_ADDRESS          [port]->write(0xdeaddead+i);
-		  in_DECOD_RAS_INDEX            [port]->write((0x12345678+i)%_param->_size_ras_index[context]);
-		  in_DECOD_MISS_IFETCH          [port]->write(false);
-		  in_DECOD_MISS_DECOD           [port]->write(false);
-		  in_DECOD_UPDATE_PREDICTION_ID [port]->write(i);
-		  
-		  if (_param->_have_port_depth[context])
-		    {
-		      TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
-		    }
-		      TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
-		  
-		  SC_START(0);
-		  
-		  LABEL("DECOD           [%d] %d - %d.",port,in_DECOD_VAL [port]->read(),out_DECOD_ACK [port]->read());
-		  
-		  if (in_DECOD_VAL [port]->read() and out_DECOD_ACK [port]->read())
-		    {
-		      LABEL("DECOD           [%d] - Transaction accepted",port);
-		      find = true;
-		    }
-		  
-		  SC_START(1);
-		  
-		} while (not find);
-	      in_DECOD_VAL              [port]->write(0);
-	      
-	      if (_param->_have_port_depth[context])
-		{
-		  TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
-		}
-		  TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
-	    }
-	}
-	
-	LABEL("BRANCH_COMPLETE - hit ifetch");
-	
-	{
-	  uint32_t port = rand() % _param->_nb_inst_branch_complete;
-	  
-	    {
-	      uint32_t i=0;
-	      bool find = false;
-	      do
-		{
-		  in_BRANCH_COMPLETE_VAL                  [port]->write((rand()%100)<percent_transaction_branch_complete);
-		  in_BRANCH_COMPLETE_CONTEXT_ID           [port]->write(context);
-		  in_BRANCH_COMPLETE_DEPTH                [port]->write(i);
-		  in_BRANCH_COMPLETE_ADDRESS              [port]->write(0xcacacaca+i);
-		  in_BRANCH_COMPLETE_FLAG                 [port]->write(0);
-		  
-		  if (_param->_have_port_depth[context])
-		    {
-		      TEST(Tdepth_t,out_DEPTH_TAIL     [context]->read(), 0);
-		    }
-		      TEST(Tdepth_t,out_DEPTH_NB_BRANCH[context]->read(), _param->_size_queue[context]);
-		  
-		  SC_START(0);
-		  
-		  LABEL("BRANCH_COMPLETE [%d] %d - %d.",port,in_BRANCH_COMPLETE_VAL [port]->read(),out_BRANCH_COMPLETE_ACK [port]->read());
-		  
-		  if (in_BRANCH_COMPLETE_VAL [port]->read() and out_BRANCH_COMPLETE_ACK [port]->read())
-		    {
-		      LABEL("BRANCH_COMPLETE [%d] - Transaction accepted",port);
-		      find = true;
-		      
-		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_MISS_PREDICTION[port]->read(),1);
-		      TEST(Tcontrol_t,out_BRANCH_COMPLETE_TAKE           [port]->read(),0);
-		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_SRC    [port]->read(),0xdeadbeef+i);
-		      TEST(Taddress_t,out_BRANCH_COMPLETE_ADDRESS_DEST   [port]->read(),0x21071981+i);
-		    }
-		  
-		  SC_START(1);
-
-		} while (not find);
-	      in_BRANCH_COMPLETE_VAL              [port]->write(0);
-	    }
-	}
-	
-	LABEL("UPDATE - miss ifetch");
-	
-	{
-	  uint32_t port = 0; //rand() % _param->_nb_inst_update;
-	  
-// 	  for (uint32_t i=0; i<_param->_size_queue[context]; i++)
-	    {
-	      uint32_t i=0;
-
-	      bool find = false;
-	      do
-		{
-		  in_UPDATE_ACK [port]->write((rand()%100)<percent_transaction_update);
-		  
-		  SC_START(0);
-		  
-		  if (out_UPDATE_VAL [port]->read() and in_UPDATE_ACK [port]->read())
-		    {
-		      LABEL("UPDATE [%d] - Transaction accepted",port);
-		      
-		      find = true;
-		      
-		      TEST(Tcontext_t         ,out_UPDATE_CONTEXT_ID            [port]->read(), context);
-		      TEST(Tcontrol_t         ,out_UPDATE_MISS_PREDICTION       [port]->read(), 1);
-		      TEST(Tcontrol_t         ,out_UPDATE_DIRECTION_GOOD        [port]->read(), 0);
-		      TEST(Tcontrol_t         ,out_UPDATE_BTB_VAL               [port]->read(), 1);
-		      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_SRC       [port]->read(), 0xdeadbeef+i);
-		      TEST(Taddress_t         ,out_UPDATE_BTB_ADDRESS_DEST      [port]->read(), 0x21071981+i);	      
-		      TEST(Tbranch_condition_t,out_UPDATE_BTB_CONDITION         [port]->read(), BRANCH_CONDITION_FLAG_SET);
-		      TEST(Tcontrol_t         ,out_UPDATE_DIR_VAL               [port]->read(), 1);
-		      if (_param->_have_port_history)
-			TEST(Thistory_t         ,out_UPDATE_DIR_HISTORY           [port]->read(), i);
-		      TEST(Tcontrol_t         ,out_UPDATE_RAS_VAL               [port]->read(), 0);
-		      TEST(Tcontrol_t         ,out_UPDATE_RAS_PUSH              [port]->read(), 0);
-		      TEST(Taddress_t         ,out_UPDATE_RAS_ADDRESS           [port]->read(), 0xdeaddead+i);
-		      TEST(Tptr_t             ,out_UPDATE_RAS_INDEX             [port]->read(), (0x12345678+i)%_param->_size_ras_index[context]);
-		      TEST(Tcontrol_t         ,out_UPDATE_RAS_PREDICTION_IFETCH [port]->read(), 1);
-		    }
-		  
-		  SC_START(1);
-		  
-		} while (not find);
-	      in_UPDATE_ACK              [port]->write(0);
-	    }
-	    
-	    LABEL("Wait a moment");
-	    SC_START(_param->_size_queue[context]);
-	    
-	    // wait the garbage collector
-	    while (((not (_param->_have_port_depth[context])) or (out_DEPTH_TAIL     [context]->read() != 0)) and
-		   (out_DEPTH_NB_BRANCH[context]->read() != 0))
-		{
-		  LABEL("DEPTH [%d] nb_branch : %d - tail : %d",context,out_DEPTH_NB_BRANCH[context]->read(), out_DEPTH_TAIL [context]->read());
-		  SC_START(1);
-		}
-	}
-      }
-
-      LABEL ("Yo1");
-      SC_START(1);
-      LABEL ("Yo2");
-
-    }
+    }// ITERATION
 
   /********************************************************
@@ -699,5 +612,5 @@
   delete []  in_PREDICT_RAS_ADDRESS         ;
   delete []  in_PREDICT_RAS_INDEX           ;
-//delete [] out_PREDICT_UPDATE_PREDICTION_ID;
+  delete [] out_PREDICT_UPDATE_PREDICTION_ID;
   
   // ~~~~~[ Interface : "decod" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -715,4 +628,5 @@
   delete []  in_DECOD_UPDATE_PREDICTION_ID  ;
 //delete [] out_DECOD_DEPTH                 ;
+  delete []  in_DECOD_IS_ACCURATE           ;
   
   // ~~~~~[ Interface : "branch_complete" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -756,6 +670,7 @@
 
   // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  delete [] out_DEPTH_NB_BRANCH;
-  delete [] out_DEPTH_TAIL;
+  delete [] out_DEPTH_CURRENT;
+  delete [] out_DEPTH_MIN;
+  delete [] out_DEPTH_MAX;
 
 #endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Parameters.h	(revision 88)
@@ -24,27 +24,30 @@
   {
     //-----[ fields ]------------------------------------------------------------
-  public : uint32_t   _nb_context             ;
-  public : uint32_t * _size_queue             ; // [nb_context]
-  public : uint32_t   _size_address           ;
-  public : uint32_t   _nb_inst_predict        ;
-  public : uint32_t   _nb_inst_decod          ;
-  public : uint32_t   _nb_inst_branch_complete;
-  public : uint32_t   _nb_inst_update         ;
-  public : uint32_t   _size_history           ;
-  public : uint32_t * _size_ras_index         ; // [nb_context]
+  public : uint32_t   _nb_context                ;
+  public : uint32_t * _size_upt_queue            ; // [nb_context]
+  public : uint32_t * _size_ufpt_queue           ; // [nb_context]
+//public : uint32_t   _size_address              ;
+  public : uint32_t   _nb_inst_predict           ;
+  public : uint32_t   _nb_inst_decod             ;
+  public : uint32_t   _nb_inst_branch_complete   ;
+  public : uint32_t   _nb_inst_update            ;
+  public : uint32_t   _size_history              ;
+  public : uint32_t * _size_ras_index            ; // [nb_context]
+  public : const bool _not_accurate_block_predict;
 
-  public : uint32_t   _size_context_id        ;
-  public : uint32_t * _size_depth             ; // [nb_context]
-  public : uint32_t   _max_size_depth         ;
-  public : uint32_t   _max_size_ras_index     ;
-		      
-  public : bool       _have_port_context_id   ;
-  public : bool     * _have_port_depth        ; // [nb_context]
-  public : bool       _have_port_max_depth    ;
-  public : bool       _have_port_history      ;
+//public : uint32_t   _size_context_id           ;
+//public : uint32_t * _size_depth                ; // [nb_context]
+//public : uint32_t   _max_size_depth            ;
+  public : uint32_t   _max_size_ras_index        ;
+		                                 
+//public : bool       _have_port_context_id      ;
+//public : bool     * _have_port_depth           ; // [nb_context]
+//public : bool       _have_port_max_depth       ;
+  public : bool       _have_port_history         ;
     
     //-----[ methods ]-----------------------------------------------------------
   public : Parameters  (uint32_t   nb_context             ,
-			uint32_t * size_queue             ,
+			uint32_t * size_upt_queue         ,
+			uint32_t * size_ufpt_queue        ,
 			uint32_t   size_address           ,
 			uint32_t   nb_inst_predict        ,
@@ -53,7 +56,10 @@
 			uint32_t   nb_inst_update         ,
 			uint32_t   size_history           ,
-			uint32_t * size_ras_index         );
+			uint32_t * size_ras_index         ,
+                        bool       is_toplevel=false);
 //public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
+
+  public :        void            copy       (void);
 
   public :        Parameters_test msg_error  (void);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Types.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Types.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Types.h	(revision 88)
@@ -21,26 +21,85 @@
   typedef enum
     {
-      UPDATE_PREDICTION_STATE_EMPTY      , // Slot is empty
-      UPDATE_PREDICTION_STATE_WAIT_DECOD , // Fetch have access at the predictor
-      UPDATE_PREDICTION_STATE_WAITEND    , // Have make a prediction, wait branch_complete
-      UPDATE_PREDICTION_STATE_EVENT      , // have a event - must signal at the context_unit
-      UPDATE_PREDICTION_STATE_OK         , // branch is complete and can update predictor
-      UPDATE_PREDICTION_STATE_KO         , // have a event - must update predictor unit
-      UPDATE_PREDICTION_STATE_END          // branch is updated 
-    } state_t;
+      EVENT_STATE_OK                 , // Can predict
+      EVENT_STATE_FLUSH_UFPT         , // in decod  stage, detect a miss, continue to execute but flush ufpt
+      EVENT_STATE_FLUSH_UFPT_AND_UPT , // in commit stage, detect a miss, stop context and flush ufpt and upt
+      EVENT_STATE_FLUSH_UPT_RAS      , // in commit stage, detect a miss, context is stop and ufpt is flush, update RAS
+      EVENT_STATE_FLUSH_UPT          , // in commit stage, detect a miss, context is stop and ufpt is flush
+      EVENT_STATE_UPDATE_CONTEXT       // prediction unit is update, send signal to context manager
+    } event_state_t;
 
-  class entry_t
+  typedef enum
+    {
+      UPDATE_FETCH_PREDICTION_STATE_EMPTY       , // Slot is empty
+      UPDATE_FETCH_PREDICTION_STATE_WAIT_DECOD  , // Have make a prediction, wait decod
+      UPDATE_FETCH_PREDICTION_STATE_EVENT       , // previous branch is a miss prediction
+      UPDATE_FETCH_PREDICTION_STATE_END           // branch is updated 
+    } ufpt_state_t;
+
+  typedef enum
+    {
+      UPDATE_PREDICTION_STATE_EMPTY             , // Slot is empty
+      UPDATE_PREDICTION_STATE_WAIT_END          , // Have make a prediction, wait branch_complete
+      UPDATE_PREDICTION_STATE_OK                , // this branch is a hit prediction
+      UPDATE_PREDICTION_STATE_KO                , // this branch is a miss prediction
+      UPDATE_PREDICTION_STATE_EVENT             , // previous branch is a miss prediction
+      UPDATE_PREDICTION_STATE_END                 // branch is updated 
+    } upt_state_t;
+
+  class ufpt_entry_t
   {
-  public : state_t             _state;
-  public : Tcontrol_t          _ifetch_prediction;
-  public : Tbranch_condition_t _condition;
-  public : Taddress_t          _address_src;
-  public : Taddress_t          _address_dest;
-  public : Tcontrol_t          _last_take;
-  public : Tcontrol_t          _good_take;
-  public : Thistory_t          _history;
-  public : Taddress_t          _address_ras;
-  public : Tptr_t              _index_ras;
+  public : ufpt_state_t        _state            ;
+  public : Tbranch_condition_t _condition        ;
+  public : Taddress_t          _address_src      ;
+  public : Taddress_t          _address_dest     ;
+  public : Tcontrol_t          _last_take        ;
+//public : Tcontrol_t          _good_take        ;
+  public : Tcontrol_t          _is_accurate      ;
+  public : Thistory_t          _history          ;
+  public : Taddress_t          _address_ras      ;
+  public : Tptr_t              _index_ras        ;
+//public : Tcontrol_t          _ifetch_prediction;
   };
+
+  class upt_entry_t
+  {
+  public : upt_state_t         _state            ;
+  public : Tbranch_condition_t _condition        ;
+  public : Taddress_t          _address_src      ;
+  public : Taddress_t          _address_dest     ;
+  public : Tcontrol_t          _last_take        ;
+  public : Tcontrol_t          _good_take        ; // not in ufpt
+  public : Tcontrol_t          _is_accurate      ;
+  public : Thistory_t          _history          ;
+  public : Taddress_t          _address_ras      ;
+  public : Tptr_t              _index_ras        ;
+  public : Tcontrol_t          _ifetch_prediction; // not in ufpt
+  };
+
+
+// BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK          
+// BRANCH_CONDITION_NONE_WITH_WRITE_STACK             
+// BRANCH_CONDITION_FLAG_UNSET                        
+// BRANCH_CONDITION_FLAG_SET                          
+// BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK 
+// BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK    
+// BRANCH_CONDITION_READ_STACK                        
+
+
+#define update_btb(cond)  true
+
+#define update_dir(cond)  ((cond == BRANCH_CONDITION_FLAG_UNSET) or \
+                           (cond == BRANCH_CONDITION_FLAG_SET))
+
+#define update_ras(cond)  ((cond == BRANCH_CONDITION_NONE_WITH_WRITE_STACK         ) or \
+                           (cond == BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK) or \
+                           (cond == BRANCH_CONDITION_READ_STACK                    ))
+
+#define push_ras(cond)    ((cond == BRANCH_CONDITION_NONE_WITH_WRITE_STACK         ) or \
+                           (cond == BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK))
+
+#define pop_ras(cond)     ((cond == BRANCH_CONDITION_READ_STACK                    ))
+
+#define need_update(cond) update_ras(cond)
 
 }; // end namespace update_prediction_table
@@ -51,15 +110,39 @@
 }; // end namespace behavioural
   
+  template<> inline std::string toString<morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::event_state_t>(const morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::event_state_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::EVENT_STATE_OK                   : return "ok"                  ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::EVENT_STATE_FLUSH_UFPT           : return "flush_ufpt"          ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::EVENT_STATE_FLUSH_UFPT_AND_UPT   : return "flush_ufpt_and_upt"  ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::EVENT_STATE_FLUSH_UPT_RAS        : return "flush_upt_ras"       ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::EVENT_STATE_FLUSH_UPT            : return "flush_upt"           ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::EVENT_STATE_UPDATE_CONTEXT       : return "update_context"      ; break;
+      default    : return ""      ; break;
+      }
+  };
 
-  template<> inline std::string toString<morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::state_t>(const morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::state_t& x)
+  template<> inline std::string toString<morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::ufpt_state_t>(const morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::ufpt_state_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_FETCH_PREDICTION_STATE_EMPTY      : return "empty"     ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_FETCH_PREDICTION_STATE_WAIT_DECOD : return "wait_decod"; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_FETCH_PREDICTION_STATE_EVENT      : return "event"     ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_FETCH_PREDICTION_STATE_END        : return "end"       ; break;
+      default    : return ""      ; break;
+      }
+  };
+
+  template<> inline std::string toString<morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::upt_state_t>(const morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::upt_state_t& x)
   {
     switch (x)
       {
       case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_EMPTY      : return "empty"     ; break;
-      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_WAIT_DECOD : return "wait_decod"; break;
-      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_WAITEND    : return "waitend"   ; break;
-      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_EVENT      : return "event"     ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_WAIT_END   : return "wait_end"  ; break;
       case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_OK         : return "ok"        ; break;
       case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_KO         : return "ko"        ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_EVENT      : return "event"     ; break;
       case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_END        : return "end"       ; break;
       default    : return ""      ; break;
@@ -67,5 +150,4 @@
   };
 
-
 }; // end namespace morpheo              
 
